﻿using System;
using System.Linq;
using System.Windows.Forms;

using ScottPlot;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            Plot plot = new Plot(800, 600);

            Random rand = new Random(0);

            int pointCount = 5_000;

            double[] sineValueArray  = DataGen.Sin(pointCount, 3);
            double[] noiseValueArray = DataGen.RandomNormal(rand, pointCount, 0, 0.5);
            double[] yValueArray     = sineValueArray.Zip(noiseValueArray, (s, n) => s + n).ToArray();
            double[] xValueArray     = new double[pointCount];

            double x = 0;

            for(int i = 0; i < pointCount; i++)
            {
                bool lowDensityPoint = (i % 1_000) < 10;

                x += lowDensityPoint ? 10 : 0.05;

                xValueArray[i] = x;
            }

            plot.AddSignalXY(xValueArray, yValueArray);

            this.formsPlot.Reset(plot);

            this.formsPlot.Refresh();
        }

        #endregion
    }
}